package com.ejie.ab79.service.procedimientos;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.ejie.ab79.dao.procedimientos.ProcedimientosDao;
import com.ejie.ab79.model.procedimientos.Procedimientos;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableResponseDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ProcedimientosServiceImpl  
 * 
 *  
 */

@Service(value = "procedimientosService")
public class ProcedimientosServiceImpl implements ProcedimientosService {

	@Autowired
	private ProcedimientosDao procedimientosDao;

	/**
	 * Finds a single row in the Procedimientos table.
	 *
	 * @param procedimientos
	 *            Procedimientos
	 * @return Procedimientos
	 */
	@Override
	public Procedimientos find(Procedimientos procedimientos) {
		return this.procedimientosDao.find(procedimientos);
	}

	/**
	 * Finds a list of rows in the Procedimientos table.
	 *
	 * @param procedimientos
	 *            Procedimientos
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<Procedimientos>
	 */
	@Override
	public List<Procedimientos> findAll(Procedimientos procedimientos, TableRequestDto tableRequestDto) {
		return this.procedimientosDao.findAll(procedimientos, tableRequestDto);
	}

	/**
	 * Finds rows in the Procedimientos table using like.
	 *
	 * @param procedimientos
	 *            Procedimientos
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Procedimientos>
	 */
	@Override
	public List<Procedimientos> findAllLike(Procedimientos procedimientos, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		return this.procedimientosDao.findAllLike(procedimientos, tableRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the Procedimientos table.
	 *
	 * @param filterProcedimientos
	 *            Procedimientos
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	@Override
	public void removeMultiple(Procedimientos filterProcedimientos, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		this.procedimientosDao.removeMultiple(filterProcedimientos, tableRequestDto, startsWith);
	}

	/**
	 * Filter method in the Procedimientos table.
	 *
	 * @param filterProcedimientos
	 *            Procedimientos
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return TableResponseDto<Procedimientos>
	 */
	@Override
	public TableResponseDto<Procedimientos> filter(Procedimientos filterProcedimientos, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		List<Procedimientos> listaProcedimientos = this.procedimientosDao.findAllLike(filterProcedimientos,
				tableRequestDto, false);
		Long recordNum = this.procedimientosDao
				.findAllLikeCount(filterProcedimientos != null ? filterProcedimientos : new Procedimientos(), false);

		TableResponseDto<Procedimientos> usuarioDto = new TableResponseDto<Procedimientos>(tableRequestDto, recordNum,
				listaProcedimientos);

		if (tableRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<Procedimientos>> reorderSelection = this.procedimientosDao
					.reorderSelection(filterProcedimientos, tableRequestDto, startsWith);
			usuarioDto.setReorderedSelection(reorderSelection);
			usuarioDto.addAdditionalParam("reorderedSelection", reorderSelection);
			usuarioDto.addAdditionalParam("selectedAll", tableRequestDto.getMultiselection().getSelectedAll());
		}
		if (tableRequestDto.getSeeker().getSelectedIds() != null) {
			tableRequestDto.setMultiselection(tableRequestDto.getSeeker());
			List<TableRowDto<Procedimientos>> reorderSeeker = this.procedimientosDao
					.reorderSelection(filterProcedimientos, tableRequestDto, startsWith);
			usuarioDto.setReorderedSeeker(reorderSeeker);
			usuarioDto.addAdditionalParam("reorderedSeeker", reorderSeeker);
		}
		return usuarioDto;
	}

	/**
	 * Searches rows in the Procedimientos table.
	 *
	 * @param filterProcedimientos
	 *            Procedimientos
	 * @param searchProcedimientos
	 *            Procedimientos
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Procedimientos>>
	 */
	@Override
	public List<TableRowDto<Procedimientos>> search(Procedimientos filterProcedimientos,
			Procedimientos searchProcedimientos, TableRequestDto tableRequestDto, Boolean startsWith) {
		return this.procedimientosDao.search(filterProcedimientos, searchProcedimientos, tableRequestDto, startsWith);
	}

	/**
	 * Reorder the selection made in Procedimientos table.
	 *
	 * @param filterProcedimientos
	 *            Procedimientos
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	@Override
	public Object reorderSelection(Procedimientos filterProcedimientos, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		return this.procedimientosDao.reorderSelection(filterProcedimientos, tableRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the Procedimientos table.
	 *
	 * @param filterProcedimientos
	 *            Procedimientos
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return TableResponseDto<JerarquiaDto<Procedimientos>>
	 */
	@Override
	public TableResponseDto<JerarquiaDto<Procedimientos>> jerarquia(Procedimientos filterProcedimientos,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		List<JerarquiaDto<Procedimientos>> listaProcedimientos = this.procedimientosDao
				.findAllLikeJerarquia(filterProcedimientos, tableRequestDto);
		Long recordNum = this.procedimientosDao.findAllLikeCountJerarquia(filterProcedimientos, tableRequestDto);
		return new TableResponseDto<JerarquiaDto<Procedimientos>>(tableRequestDto, recordNum, listaProcedimientos);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the Procedimientos
	 * table.
	 *
	 * @param filterProcedimientos
	 *            Procedimientos
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return TableResponseDto<JerarquiaDto<Procedimientos>>
	 */
	@Override
	public TableResponseDto<JerarquiaDto<Procedimientos>> jerarquiaChildren(Procedimientos filterProcedimientos,
			TableRequestDto tableRequestDto) {
		TableResponseDto<JerarquiaDto<Procedimientos>> tableResponseDto = new TableResponseDto<JerarquiaDto<Procedimientos>>();
		tableResponseDto.addAdditionalParam(TableResponseDto.CHILDREN,
				this.procedimientosDao.findAllChild(filterProcedimientos, tableRequestDto));
		return tableResponseDto;
	}

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	@Override
	public List<Procedimientos> getMultiple(Procedimientos filterProcedimientos, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		return this.procedimientosDao.getMultiple(filterProcedimientos, tableRequestDto, startsWith);
	}

	@Override
	public List<Procedimientos> obtenerProcedimientosInicioOficio() {
		return this.procedimientosDao.obtenerProcedimientosInicioOficio();
	}

	@Override
	public Procedimientos findByProcedureId(String codProcedureId) {
		return this.procedimientosDao.findByProcedureId(codProcedureId);
	}

	@Override
	public List<Procedimientos> findAllProcedimientosAplicacion(Procedimientos procedimientos) {
		return this.procedimientosDao.findAllProcedimientosAplicacion(procedimientos);
	}

	@Override
	public boolean esProcedimientoInicioOficio(Integer idProcedimiento) {
		return this.procedimientosDao.esProcedimientoInicioOficio(idProcedimiento);
	}

	@Override
	public List<Procedimientos> obtenerProcedimientosInicioOficioByInspeccion(Integer idInspeccion) {
		return this.procedimientosDao.obtenerProcedimientosInicioOficioByInspeccion(idInspeccion);
	}

	@Override
	public Procedimientos findByIdExpediente(Integer idExpediente) {
		return this.procedimientosDao.findByIdExpediente(idExpediente);
	}
}
